diff -pruN 1.3-1/debian/changelog 1.3.1-1/debian/changelog
--- 1.3-1/debian/changelog	2016-11-20 16:46:29.000000000 +0000
+++ 1.3.1-1/debian/changelog	2018-05-16 09:50:10.000000000 +0000
@@ -1,3 +1,9 @@
+cl-zs3 (1.3.1-1) unstable; urgency=medium
+
+  * Quicklisp release update.
+
+ -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 16 May 2018 09:50:10 +0000
+
 cl-zs3 (1.3-1) unstable; urgency=medium
 
   * Quicklisp release update.
diff -pruN 1.3-1/debian/compat 1.3.1-1/debian/compat
--- 1.3-1/debian/compat	2014-04-30 14:01:04.000000000 +0000
+++ 1.3.1-1/debian/compat	2018-03-06 13:38:56.000000000 +0000
@@ -1 +1 @@
-7
\ No newline at end of file
+9
\ No newline at end of file
diff -pruN 1.3-1/debian/control 1.3.1-1/debian/control
--- 1.3-1/debian/control	2014-08-04 15:25:24.000000000 +0000
+++ 1.3.1-1/debian/control	2018-03-06 13:38:56.000000000 +0000
@@ -4,7 +4,7 @@ Priority: optional
 Maintainer: Dimitri Fontaine <dim@tapoueh.org>
 Build-Depends: debhelper (>= 7)
 Build-Depends-Indep: dh-lisp
-Standards-Version: 3.9.5
+Standards-Version: 4.1.3
 Homepage: http://xach.com/lisp/zs3/
 Vcs-Git: https://github.com/xach/zs3.git
 Vcs-Browser: https://github.com/xach/zs3
diff -pruN 1.3-1/doc/index.html 1.3.1-1/doc/index.html
--- 1.3-1/doc/index.html	2016-10-31 15:30:36.000000000 +0000
+++ 1.3.1-1/doc/index.html	2017-12-24 23:53:51.000000000 +0000
@@ -17,7 +17,7 @@
    see <a href='LICENSE'>LICENSE</a> for details. Development of ZS3
    is hosted <a href="https://github.com/xach/zs3/">on GitHub</a>.
 
-The latest version is 1.3, released on October 31st, 2016.
+The latest version is 1.3.1, released on December 24th, 2017.
 
  <p>Download shortcut: <a href='http://www.xach.com/lisp/zs3.tgz'>http://www.xach.com/lisp/zs3.tgz</a>
 
@@ -1401,6 +1401,7 @@ bucket with the given name.
       <var>content-type</var>
       <var>expires</var>
       <var>storage-class</var>
+      <var>tagging</var>
       <var>credentials</var>
       <var>backoff</var>
     </span>
@@ -1465,6 +1466,11 @@ bucket with the given name.
     from S3. For more information about reduced redundancy storage,
     see <a href="http://docs.aws.amazon.com/AmazonS3/latest/dev/Introduction.html#RRS">reduced
     Redundancy Storage</a> in the Developer Guide.
+
+    <p>If provided, <var>tagging</var> specifies the set of tags
+    to be associated with the object. The set is given as an alist.
+    For more information, see <a href="http://docs.aws.amazon.com/AmazonS3/latest/dev/object-tagging.html">
+    Object Tagging</a> in the Developer Guide.
 </div>
 
 <div class='item'>
@@ -1483,6 +1489,7 @@ bucket with the given name.
       <var>content-type</var>
       <var>expires</var>
       <var>storage-class</var>
+      <var>tagging</var>
       <var>credentials</var>
       <var>backoff</var>
     </span>
@@ -1520,6 +1527,7 @@ bucket with the given name.
       <var>content-type</var>
       <var>expires</var>
       <var>storage-class</var>
+      <var>tagging</var>
       <var>credentials</var>
       <var>backoff</var>
     </span>
@@ -1554,6 +1562,7 @@ calling:
       <var>content-disposition</var> <var>content-encoding</var> <var>content-type</var>
       <var>expires</var>
       <var>storage-class</var>
+      <var>tagging</var>
       <var>credentials</var>
       <var>backoff</var>
     </span>
@@ -1596,6 +1605,7 @@ calling:
       <var>content-disposition</var> <var>content-encoding</var> <var>content-type</var>
       <var>expires</var>
       <var>storage-class</var>
+      <var>tagging</var>
       <var>credentials</var>
       <var>backoff</var>
     </span>
@@ -1645,6 +1655,7 @@ calling:
       <var>unless-modified-since</var> <br>
       <var>metadata</var> <var>public</var> <var>precondition-errors</var>
       <var>storage-class</var>
+      <var>tagging</var>
       <var>credentials</var>
       <var>backoff</var>
     </span>
@@ -1677,6 +1688,12 @@ calling:
     means that the new object has no metadata. Otherwise, the metadata
     is copied from the original object.
 
+    <p>If <var>tagging</var> is explicitly provided, it follows the
+    same behavior as
+    with <a href='#put-object'><tt>PUT-OBJECT</tt></a>. Passing NIL
+    means that the new object has no tags. Otherwise, tagging is copied
+    from the original object.
+
     <p>If <var>storage-class</var> is provided, it should refer to one
     of the standard storage classes available for S3; currently the
     accepted values are the strings "STANDARD" and
@@ -2198,6 +2215,78 @@ calling:
   </blockquote>
 </div>
 
+<a name='tagging'><h3>Object Tagging</h3></a>
+
+<p>In S3, a set of tags can be associated with each key and
+  bucket. Tagging offers a way to categorize objects that is
+  orthogonal to key prefixes. They resemble object metadata but,
+  unlike metadata, tagging be used in access control, lifecycle
+  rules, and metrics. For more information, please refer to
+  the <a href="http://docs.aws.amazon.com/AmazonS3/latest/dev/object-tagging.html">Object
+  Tagging</a> section on the S3 Developer Guide.
+
+<div class='item'>
+  <div class='type'><a name='get-tagging'>[Function]</a></div>
+  <div class='signature'>
+    <code class='name'>get-tagging</code>
+    <span class='args'>
+      <code class='llkw'>&amp;key</code>
+      <var>bucket</var>
+      <var>key</var>
+      <var>credentials</var>
+      <var>backoff</var>
+    </span>
+    <span class='result'>=> <var>tag-set</var></span>
+  </div>
+
+  <blockquote class='description'>
+    <p>Returns the object's current tag set as an
+    alist.
+  </blockquote>
+</div>
+
+
+<div class='item'>
+  <div class='type'><a name='put-tagging'>[Function]</a></div>
+  <div class='signature'>
+    <code class='name'>put-tagging</code>
+    <span class='args'>
+      <var>tag-set</var>
+      <code class='llkw'>&amp;key</code>
+      <var>bucket</var>
+      <var>key</var>
+      <var>credentials</var>
+      <var>backoff</var>
+    </span>
+    <span class='result'>=> <var>response</var></span>
+  </div>
+
+  <blockquote class='description'>
+    <p>Sets the object's tagging resource to the given set of tags.
+    The tags are given as an alist.
+  </blockquote>
+</div>
+
+
+<div class='item'>
+  <div class='type'><a name='delete-tagging'>[Function]</a></div>
+  <div class='signature'>
+    <code class='name'>delete-tagging</code>
+    <span class='args'>
+      <code class='llkw'>&amp;key</code>
+      <var>bucket</var>
+      <var>key</var>
+      <var>credentials</var>
+      <var>backoff</var>
+    </span>
+    <span class='result'>=> <var>response</var></span>
+  </div>
+
+  <blockquote class='description'>
+    <p>Deletes the tagging resource associated with the object.
+  </blockquote>
+</div>
+
 
 <a name='misc'><h3>Miscellaneous Operations</h3></a>
 
diff -pruN 1.3-1/interface.lisp 1.3.1-1/interface.lisp
--- 1.3-1/interface.lisp	2016-10-31 15:30:36.000000000 +0000
+++ 1.3.1-1/interface.lisp	2017-12-24 23:53:51.000000000 +0000
@@ -90,6 +90,10 @@ constraint."
   (let* ((request (make-instance 'request
                                   :method :get
                                   :sub-resource "location"
+                                  :extra-http-headers
+                                  `(,(when (security-token *credentials*)
+                                       (cons "x-amz-security-token"
+                                             (security-token *credentials*))))
                                   :bucket bucket))
          (response (submit-request request))
          (location (location response)))
@@ -104,7 +108,7 @@ constraint."
 
 (defun region-endpoint (region)
   (if (string= region "us-east-1")
-      "s3.amazonaws.com"
+      (or *s3-endpoint* "s3.amazonaws.com")
       (format nil "s3-~A.amazonaws.com" region)))
 
 (defun query-bucket (bucket &key prefix marker max-keys delimiter
@@ -347,6 +351,13 @@ constraint."
 
 ;;; Putting objects
 
+(defun format-tagging-header (tagging)
+  (format nil "~{~a=~a~^&~}"
+          (mapcan #'(lambda (kv)
+                      (list
+                       (drakma:url-encode (car kv) :iso-8859-1)
+                       (drakma:url-encode (cdr kv) :iso-8859-1)))
+                  tagging)))
 
 (defun put-object (object bucket key &key
                                        access-policy
@@ -359,6 +370,7 @@ constraint."
                                        expires
                                        content-type
                                        (storage-class "STANDARD")
+                                       tagging
                                        ((:credentials *credentials*) *credentials*)
                                        ((:backoff *backoff*) *backoff*))
   (let ((content
@@ -380,7 +392,10 @@ constraint."
                                    :amz-headers
                                    (append policy-header
                                            (when security-token
-                                             (list (cons "security-token" security-token))))
+                                             (list (cons "security-token" security-token)))
+                                           (when tagging
+                                             (list
+                                              (cons "tagging" (format-tagging-header tagging)))))
                                    :extra-http-headers
                                    (parameters-alist
                                     :cache-control cache-control
@@ -404,6 +419,7 @@ constraint."
                    (content-type "binary/octet-stream")
                    expires
                    storage-class
+                   tagging
                    ((:credentials *credentials*) *credentials*)
                    ((:backoff *backoff*) *backoff*))
   (when (or start end)
@@ -417,7 +433,8 @@ constraint."
               :content-disposition content-disposition
               :content-type content-type
               :expires expires
-              :storage-class storage-class))
+              :storage-class storage-class
+              :tagging tagging))
 
 (defun put-string (string bucket key &key
                    start end
@@ -431,6 +448,7 @@ constraint."
                    (content-type "text/plain")
                    expires
                    storage-class
+                   tagging
                    ((:credentials *credentials*) *credentials*)
                    ((:backoff *backoff*) *backoff*))
   (when (or start end)
@@ -445,7 +463,8 @@ constraint."
               :content-type content-type
               :cache-control cache-control
               :string-external-format external-format
-              :storage-class storage-class))
+              :storage-class storage-class
+              :tagging tagging))
 
 
 (defun put-file (file bucket key &key
@@ -459,6 +478,7 @@ constraint."
                  (content-type "binary/octet-stream")
                  expires
                  storage-class
+                 tagging
                  ((:credentials *credentials*) *credentials*)
                  ((:backoff *backoff*) *backoff*))
   (when (eq key t)
@@ -476,7 +496,8 @@ constraint."
                 :content-encoding content-encoding
                 :content-type content-type
                 :expires expires
-                :storage-class storage-class)))
+                :storage-class storage-class
+                :tagging tagging)))
 
 (defun put-stream (stream bucket key &key
                    (start 0) end
@@ -489,6 +510,7 @@ constraint."
                    (content-type "binary/octet-stream")
                    expires
                    storage-class
+                   tagging
                    ((:credentials *credentials*) *credentials*)
                    ((:backoff *backoff*) *backoff*))
   (let ((content (stream-subset-vector stream start end)))
@@ -501,7 +523,8 @@ constraint."
                 :content-encoding content-encoding
                 :content-type content-type
                 :expires expires
-                :storage-class storage-class)))
+                :storage-class storage-class
+                :tagging tagging)))
 
 
 ;;; Delete & copy objects
@@ -600,6 +623,7 @@ constraint."
                     public
                     precondition-errors
                     (storage-class "STANDARD")
+                    (tagging nil tagging-supplied-p)
                       ((:credentials *credentials*) *credentials*)
                       ((:backoff *backoff*) *backoff*))
   "Copy the object identified by FROM-BUCKET/FROM-KEY to
@@ -612,6 +636,10 @@ If METADATA is provided, it should be an
 values to set on the new object. Otherwise, the source object's
 metadata is copied.
 
+If TAGGING is provided, it should be an alist of tag keys and values
+to be set on the new object's tagging resource. Otherwise, the source
+object's tagging is copied.
+
 Optional precondition variables are WHEN-ETAG-MATCHES,
 UNLESS-ETAG-MATCHES, WHEN-MODIFIED-SINCE, UNLESS-MODIFIED-SINCE. The
 etag variables use an etag as produced by the FILE-ETAG function,
@@ -640,6 +668,8 @@ users. Otherwise, a default ACL is prese
                              :storage-class storage-class
                              :metadata-directive
                              (if metadata-supplied-p "REPLACE" "COPY")
+                             :tagging-directive
+                             (if tagging-supplied-p "REPLACE" "COPY")
                              :copy-source-if-match when-etag-matches
                              :copy-source-if-none-match unless-etag-matches
                              :copy-source-if-modified-since
@@ -648,14 +678,18 @@ users. Otherwise, a default ACL is prese
                              :copy-source-if-unmodified-since
                              (and unless-modified-since
                                   (http-date-string unless-modified-since))))
-          (policy-header (access-policy-header access-policy public)))
+          (policy-header (access-policy-header access-policy public))
+          (tagging-header (when tagging-supplied-p
+                            (list (cons "tagging" (format-tagging-header tagging))))))
       (submit-request (make-instance 'request
                                      :method :put
                                      :bucket to-bucket
                                      :key to-key
                                      :metadata metadata
                                      :amz-headers
-                                     (nconc headers policy-header))))))
+                                     (nconc headers
+                                            policy-header
+                                            tagging-header))))))
 
 
 (defun object-metadata (bucket key
@@ -863,7 +897,7 @@ TARGET-BUCKET with a key prefix of TARGE
              (url-encode key :encode-slash nil)
              sub-resource))))
 
-(defun authorized-url (&key bucket key vhost expires ssl sub-resource
+(defun authorized-url (&key bucket key vhost expires ssl sub-resource content-disposition content-type
                          ((:credentials *credentials*) *credentials*))
   (unless (and expires (integerp expires) (plusp expires))
     (error "~S option must be a positive integer" :expires))
@@ -872,7 +906,12 @@ TARGET-BUCKET with a key prefix of TARGE
          (endpoint (case vhost
                      (:cname bucket)
                      (:amazon (format nil "~A.~A" bucket region-endpoint))
+                     (:wasabi (format nil "~a.s3.wasabisys.com" bucket))
                      ((nil) region-endpoint)))
+         (extra-parameters (append (if content-disposition
+                                       (list (cons "response-content-disposition" content-disposition)))
+                                   (if content-type
+                                       (list (cons "response-content-type" content-type)))))
          (request (make-instance 'url-based-request
                                  :method :get
                                  :bucket bucket
@@ -880,7 +919,8 @@ TARGET-BUCKET with a key prefix of TARGE
                                  :endpoint endpoint
                                  :sub-resource sub-resource
                                  :key key
-                                 :expires (unix-time expires))))
+                                 :expires (unix-time expires)
+                                 :parameters extra-parameters)))
     (setf (amz-headers request) nil)
     (setf (parameters request)
           (parameters-alist "X-Amz-Algorithm" "AWS4-HMAC-SHA256"
@@ -911,6 +951,13 @@ TARGET-BUCKET with a key prefix of TARGE
                  (url-encode key :encode-slash nil)
                  sub-resource
                  parameters))
+        (:wasabi
+         (format nil "http~@[s~*~]://~A/~@[~A~]?~@[~A&~]~A"
+                 ssl
+                 endpoint
+                 (url-encode key :encode-slash nil)
+                 sub-resource
+                 parameters))
         ((nil)
          (format nil "http~@[s~*~]://~A/~@[~A/~]~@[~A~]?~@[~A&~]~A"
                  ssl
@@ -920,7 +967,6 @@ TARGET-BUCKET with a key prefix of TARGE
                  sub-resource
                  parameters))))))
 
-
 ;;; Miscellaneous operations
 
 (defparameter *me-cache*
@@ -949,3 +995,59 @@ multiple values."
                                :conditions conditions)))
     (values (policy-string64 policy)
             (policy-signature (secret-key *credentials*) policy))))
+
+;;; Tagging
+
+(defbinder get-tagging-result
+  ("Tagging"
+   ("TagSet"
+    (sequence :tag-set
+              ("Tag"
+               ("Key" (bind :key))
+               ("Value" (bind :value)))))))
+
+(defun get-tagging (&key bucket key
+                      ((:credentials *credentials*) *credentials*)
+                      ((:backoff *backoff*) *backoff*))
+  "Returns the current contents of the object's tagging resource as an alist."
+  (let* ((request (make-instance 'request
+                                 :method :get
+                                 :bucket bucket
+                                 :key key
+                                 :sub-resource "tagging"))
+         (response (submit-request request))
+         (tagging (xml-bind 'get-tagging-result (body response))))
+    (mapcar #'(lambda (tag)
+                (cons (bvalue :key tag)
+                      (bvalue :value tag)))
+            (bvalue :tag-set tagging))))
+
+(defun put-tagging (tag-set &key bucket key
+                              ((:credentials *credentials*) *credentials*)
+                              ((:backoff *backoff*) *backoff*))
+  "Sets the tag set, given as an alist, to the object's tagging resource."
+  (let* ((content (with-xml-output
+                    (with-element "Tagging"
+                      (with-element "TagSet"
+                        (dolist (tag tag-set)
+                          (with-element "Tag"
+                            (with-element "Key" (cxml:text (car tag)))
+                            (with-element "Value" (cxml:text (cdr tag)))))))))
+         (request (make-instance 'request
+                                 :method :put
+                                 :bucket bucket
+                                 :key key
+                                 :sub-resource "tagging"
+                                 :content content)))
+    (submit-request request)))
+
+(defun delete-tagging (&key bucket key
+                         ((:credentials *credentials*) *credentials*)
+                         ((:backoff *backoff*) *backoff*))
+  "Deletes the object's tagging resource."
+  (let* ((request (make-instance 'request
+                                 :method :delete
+                                 :bucket bucket
+                                 :key key
+                                 :sub-resource "tagging")))
+    (submit-request request)))
diff -pruN 1.3-1/package.lisp 1.3.1-1/package.lisp
--- 1.3-1/package.lisp	2016-10-31 15:30:36.000000000 +0000
+++ 1.3.1-1/package.lisp	2017-12-24 23:53:51.000000000 +0000
@@ -104,6 +104,10 @@
            #:enable-logging
            #:disable-logging
            #:logging-setup)
+  ;; Tagging
+  (:export #:get-tagging
+           #:put-tagging
+           #:delete-tagging)
   ;; Misc.
   (:export #:*use-ssl*
            #:*use-keep-alive*
diff -pruN 1.3-1/zs3.asd 1.3.1-1/zs3.asd
--- 1.3-1/zs3.asd	2016-10-31 15:30:36.000000000 +0000
+++ 1.3.1-1/zs3.asd	2017-12-24 23:53:51.000000000 +0000
@@ -34,7 +34,7 @@
                #:ironclad
                #:puri
                #:cl-base64)
-  :version "1.3"
+  :version "1.3.1"
   :description "A Common Lisp library for working with Amazon's Simple
   Storage Service (S3) and CloudFront content delivery service."
   :author "Zach Beane <xach@xach.com>"
